##############################################################################     
#      
# Zope Public License (ZPL) Version 0.9.7     
# ---------------------------------------     
#      
# Copyright (c) Digital Creations.  All rights reserved.     
#      
# This license has been certified as Open Source(tm).     
#      
# Redistribution and use in source and binary forms, with or without     
# modification, are permitted provided that the following conditions are     
# met:     
#      
# 1. Redistributions in source code must retain the above copyright     
#    notice, this list of conditions, and the following disclaimer.     
#      
# 2. Redistributions in binary form must reproduce the above copyright     
#    notice, this list of conditions, and the following disclaimer in     
#    the documentation and/or other materials provided with the     
#    distribution.     
#      
# 3. Digital Creations requests that attribution be given to Zope     
#    in any manner possible. Zope includes a "Powered by Zope"     
#    button that is installed by default. While it is not a license     
#    violation to remove this button, it is requested that the     
#    attribution remain. A significant investment has been put     
#    into Zope, and this effort will continue if the Zope community     
#    continues to grow. This is one way to assure that growth.     
#      
# 4. All advertising materials and documentation mentioning     
#    features derived from or use of this software must display     
#    the following acknowledgement:     
#      
#      "This product includes software developed by Digital Creations     
#      for use in the Z Object Publishing Environment     
#      (http://www.zope.org/)."     
#      
#    In the event that the product being advertised includes an     
#    intact Zope distribution (with copyright and license included)     
#    then this clause is waived.     
#      
# 5. Names associated with Zope or Digital Creations must not be used to     
#    endorse or promote products derived from this software without     
#    prior written permission from Digital Creations.     
#      
# 6. Modified redistributions of any form whatsoever must retain     
#    the following acknowledgment:     
#      
#      "This product includes software developed by Digital Creations     
#      for use in the Z Object Publishing Environment     
#      (http://www.zope.org/)."     
#      
#    Intact (re-)distributions of any official Zope release do not     
#    require an external acknowledgement.     
#      
# 7. Modifications are encouraged but must be packaged separately as     
#    patches to official Zope releases.  Distributions that do not     
#    clearly separate the patches from the original work must be clearly     
#    labeled as unofficial distributions.  Modifications which do not     
#    carry the name Zope may be packaged in any form, as long as they     
#    conform to all of the clauses above.     
#      
#      
# Disclaimer     
#      
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY     
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE     
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR     
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS     
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,     
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT     
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND     
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,     
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF     
#   SUCH DAMAGE.     
#      
#      
# This software consists of contributions made by Digital Creations and     
# many individuals on behalf of Digital Creations.  Specific     
# attributions are listed in the accompanying credits file.     
#      
##############################################################################     
#      
# Portions Copyright (c) 1999 by Butch Landingin.     
#      
# Redistribution and use in source and binary forms, with or without     
# modification, are permitted provided that the following conditions     
# are met:     
# 1. Redistributions of source code must retain the above copyright     
#    including the original copyright, this copyright notice, the list of      
#    conditions and the following disclaimer.     
# 2. Redistributions in binary form must reproduce the above copyright     
#    including the original copyright, this copyright notice, the list of      
#    conditions and the following disclaimer in the     
#    documentation and/or other materials provided with the distribution.     
# 3. The name of the author may not be used to endorse or promote products     
#    derived from this software without specific prior written permission     
#     
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR     
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES     
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,     
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT     
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,     
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF     
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.     
#       
#  In accordance with the license provided for by the software upon     
#  which some of the source code has been derived or used, the following      
#  acknowledgement is hereby provided :     
#     
#      "This product includes software developed by Digital Creations     
#      for use in the Z Object Publishing Environment     
#      (http://www.zope.org/)."     
#      
##############################################################################     

__doc__ = """MyAdmin product module.
This module provides the methods and classes that Zope needs for the product. 
__init__.py is responsible for registering these methods and classes.
See README.txt for more details."""

__version__ = '0.1' 

from Globals import DTMLFile      
from Globals import MessageDialog 
from Globals import Persistent  
from Globals import HTML        

import OFS.SimpleItem
import Acquisition
import ts_regex
import AccessControl.Role
from AccessControl import getSecurityManager
from Acquisition import aq_base


import regex, re, os, sys

import OFS.ObjectManager 
import OFS.CopySupport 
import OFS.Application

import Products.ZMySQLDA.DA
import Products.ZMySQLDA.db

import OFS.XMLExportImport
customImporters={
    OFS.XMLExportImport.magic: OFS.XMLExportImport.importXML,
    }

_marker=[]
bad_id=ts_regex.compile('[^a-zA-Z0-9-_~\,\. ]').match 

tempVar=""
tmpConStr=""

"""Step #1: Provide "constructors" for Zope's management interface. 
appropriate DTML document based on a file sitting in your product 
directory. 
"""

manage_addMyAdminForm = DTMLFile('MyAdminAdd', globals()) 
def manage_addMyAdmin(self,id,title='',REQUEST=None):
    """Add a MyAdmin to a folder."""
    self._setObject(id, MyAdmin(id, title))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


"""Step #2: Provide the class for your MyAdmin object."""
class MyAdmin(
    OFS.SimpleItem.Item,   
    Persistent,            
    Acquisition.Implicit,   
    AccessControl.Role.RoleManager,
    OFS.CopySupport.CopyContainer,
    OFS.ObjectManager.ObjectManager,
    OFS.Application.Application
    ): 
    """MyAdmin object. 
    
    This is an attempt at writing a product from scratch using mostly 
    Python instead of ZClasses. We'll see how it all goes.
    """
        
    meta_type = 'MyAdmin' 
    _objects   =()
    
    manage_options = ( 
	{'label': 'Contents',       'action': 'manage_main'},
	{'label': 'View',       'action': 'manage_view'}, 
        ) 

    __ac_permissions__=(
	('View management screens', ('manage_tabs','manage_main')),
	('View MyAdmin',            ('manage_view',)                        ),
	)
	
    def __init__(self, id, title=''): 
        """initialize a new instance of MyAdmin"""
	        
        self.id=id
        self.title=title
       

        self.DefaultLeftFrameBackGroundColor = """gainsboro"""
        self.DefaultBackGroundColor = """gainsboro"""
      	self.DefaultFontFamily = """tahoma"""
      	self.DefaultFontSize = """10"""
      	
        self.LeftFrameBackGroundColor = """gainsboro"""
        self.BackGroundColor = """gainsboro"""
      	self.FontFamily = """tahoma"""
      	self.FontSize = """10"""
      	      	
    manage_view = DTMLFile('index', globals()) 
    manage_main = DTMLFile('MyAdminImport', globals()) 
    
    
	
##	if REQUEST is not None:
##            REQUEST['RESPONSE'].redirect(REQUEST['URL1']+'/zopeMyAdmin/manage_workspace')
    _checkId = OFS.ObjectManager.checkValidId

    def _setOb(self, id, object): setattr(self, id, object)
    def _delOb(self, id): delattr(self, id)
    def _getOb(self, id, default=_marker):
        # FIXME: what we really need to do here is ensure that only
        # sub-items are returned. That could have a measurable hit
        # on performance as things are currently implemented, so for
        # the moment we just make sure not to expose private attrs.
        if id[:1] != '_' and hasattr(aq_base(self), id):
            return getattr(self, id)
        if default is _marker:
            raise AttributeError, id
        return default
        
    def _delObject(self, id, dp=1):
        object=self._getOb(id)
        try:
            object.manage_beforeDelete(object, self)
        except BeforeDeleteException, ob:
            raise
        except:
            LOG('Zope',ERROR,'manage_beforeDelete() threw',
                error=sys.exc_info())
            pass
        self._objects=tuple(filter(lambda i,n=id: i['id']!=n, self._objects))
        self._delOb(id)

        # Indicate to the object that it has been deleted. This is 
        # necessary for object DB mount points. Note that we have to
        # tolerate failure here because the object being deleted could
        # be a Broken object, and it is not possible to set attributes
        # on Broken objects.
        try:    object._v__object_deleted__ = 1
        except: pass

    def _setObject(self,id,object,roles=None,user=None, set_owner=1):
        if(id == "MySQL_database_connection"):
            v=self._checkId(id,1)
        else:
            v=self._checkId(id)
        if v is not None: id=v
        try:    t=object.meta_type
        except: t=None

        # If an object by the given id already exists, remove it.
        for object_info in self._objects:
            if object_info['id'] == id:
                self._delObject(id)
                break

        self._objects=self._objects+({'id':id,'meta_type':t},)
        # Prepare the _p_jar attribute immediately. _getCopy() may need it.
        if hasattr(object, '_p_jar') and object._p_jar is None:
            object._p_jar = self._p_jar
        self._setOb(id,object)
        object=self._getOb(id)

        if set_owner:
            object.manage_fixupOwnershipAfterAdd()

             # Try to give user the local role "Owner", but only if
            # no local roles have been set on the object yet.
            if hasattr(object, '__ac_local_roles__'):
                if object.__ac_local_roles__ is None:
                    user=getSecurityManager().getUser()
                    name=user.getUserName()
                    if name != 'Anonymous User':
                        object.manage_setLocalRoles(name, ['Owner'])

        object.manage_afterAdd(object, self)
        return id
    
   
    def objectIds(self, spec=None):
        """Return a list of subobject ids.
        Returns a list of subobject ids of the current object.  If 'spec' is
        specified, returns objects whose meta_type matches 'spec'.
        """
        if spec is not None:
            if type(spec)==type('s'):
                spec=[spec]
            set=[]
            for ob in self._objects:
                if ob['meta_type'] in spec:
                    set.append(ob['id'])
            return set
        return map(lambda i: i['id'], self._objects)

    def objectItems(self, spec=None):
        """Return a list of (id, subobject) tuples.
        Returns a list of (id, subobject) tuples of the current object.
        If 'spec' is specified, returns only objects whose meta_type match
        'spec'
        """
        r=[]
        a=r.append
        g=self._getOb
        for id in self.objectIds(spec):
            if id !="MySQL_database_connection":
                a((id, g(id)))
            else:
                pass
        return r
    
    
    def manage_importObject(self, REQUEST=None, set_owner=1):
        """Import an object from a file"""
        file='zopeMyAdmin.zexp'
        file=os.path.join(INSTANCE_HOME, 'lib/python/Products/MyAdmin', file)
	
        connection=self._p_jar
        obj=self

        # store away the length of the ZGlobals registry to compare
        # later to decide if dependency fixups are needed for ZClasses
        zglobals=connection.root()['ZGlobals']
        try:    keys_len=len(zglobals.keys())
        except: keys_len=None
        while connection is None:
            obj=obj.aq_parent
            connection=obj._p_jar
        ob=connection.importFile(file, customImporters=customImporters)
        
        if REQUEST: self._verifyObjectPaste(ob, validate_src=0)
        #id=ob.getId()
        #can't use above getId() call, it fails on 'old' exported objects
        id=ob.id
        if hasattr(id, 'im_func'): id=id()
        self._setObject(id, ob, set_owner=set_owner)

        # try to make ownership implicit if possible in the context
        # that the object was imported into.
        ob=self._getOb(id)
        ob.manage_changeOwnershipType(explicit=0)

        try:    new_len=len(zglobals.keys())
        except: new_len=None
        if (keys_len is not None) and (new_len is not None):
            if new_len > keys_len:
                # Looks like one or more ZClasses registered themselves
                # (in their manage_afterAdd called after the import).
                self.getPhysicalRoot().fixupZClassDependencies()

        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(REQUEST['URL1']+'/zopeMyAdmin/manage_workspace')  
    
    
    def SetConnectionString(self,UserName,Password,DatabaseName,REQUEST=None):
    	"""does this really need a doc string?"""
    	if (DatabaseName == ''):
            DatabaseName = "mysql"
      	connection_string = DatabaseName + " " + UserName + " " + Password
	
	id1="MySQL_database_connection"
	title1="Z MySQL Database Connection"
	check="YES"
	
	try:
            self._setObject(id1, Connection(id1,title1,connection_string,check))
        except:
            message = """<html><head><style>body { background-color:gainsboro;}
            :visited{color: #0000ff;} 
            font { font-family:tahoma;font-size:10pt;}
            h2 { text-align: center;font-family:tahoma;}
            h3 { font-family:tahoma;}td { font-family:tahoma;font-size:10pt;}
            th { font-family:tahoma;font-size:10pt;}</style></head><BODY :visited>
            <form action="index_html" method="post">
            <div align="center"><img src="productbigicon"></div><br><hr>
            <div align="center"><p>Authentication Failed for MySQL user </p>
            <input type="SUBMIT" name="ok" value="  Ok  ">
            </div></form></body></html>"""
	    return message;
	    
        else:
            if REQUEST is not None:
                REQUEST['RESPONSE'].setCookie('zopeMyAdminAuth','true')
                REQUEST['RESPONSE'].redirect(REQUEST['URL1']+'/parent_frame')

    def getRightFrameCSSData(self, REQUEST=None):
        """does this really need a doc string?"""
        s="""<style>
        body { background-color:"""+self.BackGroundColor+""";
             }
        :visited        {color: #0000ff;} 
        font { font-family:"""+self.FontFamily+""";
               font-size:"""+self.FontSize+"""pt;
             }
        h2 { text-align: center;
             font-family:"""+self.FontFamily+""";
           }
        h3 { font-family:"""+self.FontFamily+""";
           }  
        td { font-family:"""+self.FontFamily+""";
               font-size:"""+self.FontSize+"""pt;
           }
        th { font-family:"""+self.FontFamily+""";
               font-size:"""+self.FontSize+"""pt;
           }
        </style>"""
        return s
        
    def getLeftFrameCSSData(self):
        """does this really need a doc string?"""
        s="""<STYLE>
        BODY { BACKGROUND-COLOR:""" +self.LeftFrameBackGroundColor+""";
             }

        :VISITED { COLOR: #0000FF; }

        FONT { FONT-FAMILY:tahoma;
               FONT-SIZE:10pt;
             }
        </STYLE>"""
        return s
    
    def SetCSSData(self,LeftFrameBackGroundColor,BackGroundColor,FontFamily,FontSize, REQUEST=None):
        """does this really need a doc string?"""
        if(LeftFrameBackGroundColor == ''):
            self.LeftFrameBackGroundColor = self.DefaultLeftFrameBackGroundColor
        else:
            self.LeftFrameBackGroundColor = LeftFrameBackGroundColor  
              
        if(BackGroundColor == ''):
            self.BackGroundColor = self.DefaultBackGroundColor
        else:
            self.BackGroundColor = BackGroundColor 
                
        if(FontFamily == ''):
            self.FontFamilyr = self.DefaultFontFamily
        else:
            self.FontFamily = FontFamily  
          
        if(FontSize == ''):
            self.FontSize = self.DefaultFontSize
        else:
            self.FontSize = FontSize  
             
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(REQUEST['URL1']+'/parent_frame')
            
    def SetDefaultValues(self,REQUEST=None):
        """does this really need a doc string?"""
        
        self.LeftFrameBackGroundColor = self.DefaultLeftFrameBackGroundColor
        self.BackGroundColor = self.DefaultBackGroundColor      
        self.FontFamily = self.DefaultFontFamily
        self.FontSize = self.DefaultFontSize
        
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(REQUEST['URL1']+'/parent_frame')
    
    def removeConnection(self,REQUEST=None):
        """does this really need a doc string?"""
        self._delObject('MySQL_database_connection')
        
       
class Connection(Products.ZMySQLDA.DA.Connection):
    """A database connection object"""
    pass
    
    def factory(self):
        return DB

class DB(Products.ZMySQLDA.db.DB):
    pass
	         
     
               

         
 	 

     			
     			
        
                         
                 
                 




   
    
    
        
